# Copyright 2012 Sim Ayers
# version 1.0
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------


module ROOFFRAMING

class TetrahedronSliceTool < PlanAngleTool

$miter_angle = 33.69007;
$bevel_angle = 39.76216;
$show_angles = "no";
$rafter_width = 5.5;
def initialize
       
  
   $show_angles = "no" if not $show_angles;
   $miter_angle = 33.69007 if not $miter_angle;
   $bevel_angle = 39.76216 if not $bevel_angle;
    $rafter_width = 5.5 if not $rafter_width;

    # First prompt for the dimensions.  This is done using the inputbox method
        
    # The first step is to create some arrays which contain the prompts
    # and default values.
    prompts = ["Miter Angle","Bevel Angle","Rafter Width","Dim Angles"]
    #default values
    values = [$miter_angle,$bevel_angle,$rafter_width,$show_angles]
    
    popups = [nil, nil, nil,"no|yes"]
    
    # Now display the inputbox
    results = inputbox prompts, values,popups, "Tetrahedron Slice Tool";

    return if not results # This means that the user cancelled the operation
    $miter_angle,$bevel_angle,$rafter_width,$show_angles = results
    
    
    if ($rafter_width <= 0.0 )
     	UI.messagebox("Rafter Width can not be 0.")
     	return
    end
        
    show = true
    show = false if($show_angles == "no")
 
    	draw_tetrahedron_slice($miter_angle,$bevel_angle,$rafter_width,show);  
 
    
end


 
# draw the plan angle dimensions unfolded
def draw_tetrahedron_slice(miter_angle,bevel_angle,rafter_width,show)  

    model = Sketchup.active_model
    # this enables undo of the whole operation as a unit
    model.start_operation "Tetrahedron Slice"

    # create a new group in which we will draw our dimension entities
    model_ents = model.active_entities
    group = model_ents.add_group
    ents = group.entities
    group.name="Tetrahedron Slice"
    wplayer=model.layers.add("Tetrahedron Slice")
    wplayer.visible=true
    group.layer=wplayer
    group.casts_shadows=false
    group.receives_shadows=false       
    
	puts "Tetrahedron Slice dimensions " if $DEBUG_VERBOSE;
		
	p1 = [0,0,0]
	radius = rafter_width/3; #radius used for angluar text position
  miter= miter_angle.degrees;
  bevel = bevel_angle.degrees;
    
  draw_slice(p1,miter,bevel,rafter_width,show,radius,ents);
  p1 = [0-(rafter_width*2),0,0]
  
  angle = draw_slice_unfolded(p1,miter,bevel,rafter_width,show,radius,ents);
  
    p1 = [rafter_width*2,0,0]
    draw_tetrahedron_unfolded(p1,bevel_angle,angle,rafter_width,false,false,false); 
      show = false;
   	draw_tetrahedron(p1,bevel_angle,angle,rafter_width,show,true,true,true,false);
 
        
    Sketchup.active_model.rendering_options["ModelTransparency"]=true 
    view = Sketchup.active_model.active_view 
    view.field_of_view = 30
    #result = Sketchup.send_action 10501; # set view to Top
    view.zoom_extents 

    #group.to_component 
    model.commit_operation
    
   
 end # end function
 
 
   
end # class TetrahedronSliceTool 

end #module ROOFFRAMING

file_loaded("RoofFraming/Tetrahedron_Slice.rb")
